## ros-kinetic-control-toolbox 1.17.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(control_toolbox)

# Load catkin and all dependencies required for this package
find_package(catkin REQUIRED COMPONENTS
  cmake_modules
  control_msgs
  dynamic_reconfigure
  message_generation
  realtime_tools
  roscpp
  std_msgs
  )

find_package(Boost REQUIRED COMPONENTS system thread)
find_package(TinyXML REQUIRED)

# Dynamics reconfigure
generate_dynamic_reconfigure_options(
  cfg/Parameters.cfg
  )

# Add services and generate them
add_service_files(
  FILES
  SetPidGains.srv
  )

generate_messages(
  DEPENDENCIES std_msgs
)

# Declare catkin package
catkin_package(
  DEPENDS TinyXML
  CATKIN_DEPENDS
    control_msgs
    dynamic_reconfigure
    message_runtime
    realtime_tools
    roscpp
    std_msgs
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  )

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIR}
  ${TinyXML_INCLUDE_DIRS}
  )

add_library(${PROJECT_NAME}
  src/dither.cpp
  src/limited_proxy.cpp
  src/pid.cpp
  src/pid_gains_setter.cpp
  src/sine_sweep.cpp
  src/sinusoid.cpp
  )
add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

target_link_libraries(${PROJECT_NAME} ${TinyXML_LIBRARIES} ${catkin_LIBRARIES} ${Boost_LIBRARIES})

if(CATKIN_ENABLE_TESTING)
  # Tests
  catkin_add_gtest(pid_tests test/pid_tests.cpp)
  target_link_libraries(pid_tests ${catkin_LIBRARIES} ${PROJECT_NAME})

  # add_executable(test_linear test/linear.cpp)
endif()

# Install
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )

install(DIRECTORY scripts/
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

=== debian/changelog ===
ros-kinetic-control-toolbox (1.17.0-0xenial) xenial; urgency=high

  * update anti windup clamping
  * update negativeIntegrationAntiwindupTest
  * Address catkin_lint issues
  * Add executable flag
  * convert to package xml format 2
  * Remove doc header
  * Contributors: Bence Magyar, Cong, Gennaro Raiola

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 31 Jan 2019 00:00:00 -0000

ros-kinetic-control-toolbox (1.16.0-0xenial) xenial; urgency=high

  * switched to industrial_ci
  * Add control_msgs to CATKIN_DEPENDS.
  * Contributors: Bence Magyar, Mathias Luedtke, Mike Purvis

 -- Sachin Chitta <sachinc@willowgarage.com>  Thu, 30 Nov 2017 00:00:00 -0000

ros-kinetic-control-toolbox (1.15.0-0xenial) xenial; urgency=high

  * avoid ABI breaks in PID class
  * fix add_dependencies call
  * rollback API changes in PID class
  * cfg: removed rosbuild support related error handling
  * Contributors: Bence Magyar, Igor Napolskikh, ipa-mig

 -- Sachin Chitta <sachinc@willowgarage.com>  Mon, 27 Jun 2016 23:00:00 -0000

ros-kinetic-control-toolbox (1.14.0-0xenial) xenial; urgency=high

  * Fix negative gains issue and add tests; update gains setting through DynamicReconfig
  * Add antiwindup and tests to PID controller; rename old behaviour 'clamping'
  * Move message to control_toolbox
  * Add optional state publishing to PID controller, for logging/debugging/etc
  * Fix some typos in comments
  * changed the range of dynamic reconfigure to allow negative ones
  * Address -Wunused-parameter warnings
  * Factor out updatePid as negative calls to computeCommand
  * Increasing covergae of PID class test suite.
  * Chain calls of computeCommand and updatePid for code reuse
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Bence Magyar, Carlos Rosales, Guillaume Walck, Paul Bovbel, VahidAminZ

 -- Sachin Chitta <sachinc@willowgarage.com>  Mon, 02 May 2016 23:00:00 -0000

ros-kinetic-control-toolbox (1.13.2-0xenial) xenial; urgency=high

  * CRITICAL BUGFIX: Fix broken PID command computation.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Paul Bovbel

 -- Sachin Chitta <sachinc@willowgarage.com>  Thu, 21 May 2015 23:00:00 -0000

ros-kinetic-control-toolbox (1.13.1-0xenial) xenial; urgency=high

  * Improvement in integral contribution implementation. Resolve #32 <https://github.com/ros-controls/control_toolbox/issues/32>.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Carlos Rosales

 -- Sachin Chitta <sachinc@willowgarage.com>  Wed, 29 Apr 2015 23:00:00 -0000

ros-kinetic-control-toolbox (1.13.0-0xenial) xenial; urgency=high

  * Harmonize pid gain names between rosparam and dynamic_reconfigure
  * Read i_clamp_min and i_clamp_max form parameter server - if available
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman, ipa-fxm

 -- Sachin Chitta <sachinc@willowgarage.com>  Fri, 31 Oct 2014 00:00:00 -0000

ros-kinetic-control-toolbox (1.12.1-0xenial) xenial; urgency=high

  * Remove broken test code. Hotfix for #18 <https://github.com/ros-controls/control_toolbox/issues/18>.
  * Contributors: Adolfo Rodriguez Tsouroukdissian

 -- Sachin Chitta <sachinc@willowgarage.com>  Wed, 11 Jun 2014 23:00:00 -0000

ros-kinetic-control-toolbox (1.12.0-0xenial) xenial; urgency=high

  * pid: Adding quiet flag to suppress error message
  * Contributors: Jonathan Bohren

 -- Sachin Chitta <sachinc@willowgarage.com>  Wed, 11 Jun 2014 23:00:00 -0000

ros-kinetic-control-toolbox (1.11.0-0xenial) xenial; urgency=high

  * Remove rosbuild artifacts
  * Cleaned up CMake and removed unnecessary dependencies
  * Made default value negative to match valid range
  * Fix for i_clamp_min to be negative in dynamic reconfigure
  * Fix abs/fabs problem with Clang and libc++
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman, Marco Esposito

 -- Sachin Chitta <sachinc@willowgarage.com>  Sun, 11 May 2014 23:00:00 -0000

ros-kinetic-control-toolbox (1.10.4-0xenial) xenial; urgency=high

  * Added Travis support
  * Renamed manifest.xml so it doesn't break rosdep
  * Expanded range of PID and windup gains for certain applications.
  * Expanded range of PID and windup gains for certain applications. Lowered default integral and derivative gain
  * check for CATKIN_ENABLE_TESTING
  * Add some comments to Parameters.cfg
  * Add support for dynamic_reconfigure for rosbuild
  * Contributors: Austin Hendrix, Dave Coleman, Lukas Bulwahn, Paul Dinh

 -- Sachin Chitta <sachinc@willowgarage.com>  Wed, 05 Feb 2014 00:00:00 -0000

ros-kinetic-control-toolbox (1.10.3-0xenial) xenial; urgency=high

  * Fix bug in copy constructor.
  * Contributors: Austin Hendrix

 -- Sachin Chitta <sachinc@willowgarage.com>  Thu, 01 Aug 2013 23:00:00 -0000

ros-kinetic-control-toolbox (1.10.2-0xenial) xenial; urgency=high

  * Fix copy constructor.
  * Merge pull request #1 <https://github.com/ros-controls/control_toolbox/issues/1> from davetcoleman/hydro-devel
    Added dynamic reconfigure for PID gains
  * Removed const getGains function
  * Small fixes
  * Compatibility changes for realtime_tools, tweaked getests
  * Made realtime_buffer copiable
  * Added test for getting/settings gains, copying/assigning pid class
  * Removed const read, added copy constructor and print values function
  * Added new function getGainsConst that allows one to get the PID gains from a const PID class
  * Added realtime_tools as a dependency in package.xml and CMakeLists
  * Added realtime buffer to PID, re-ordered functions to more logical order and to match header file
  * Fixes per Austin review
  * Updated CMakeLists.txt and made fixes per Adolfo
  * Merged hydro-devel
  * Added dynamic reconfigure for PID gains
  * Tests build.
  * Contributors: Austin Hendrix, Dave Coleman

 -- Sachin Chitta <sachinc@willowgarage.com>  Sun, 28 Jul 2013 23:00:00 -0000

ros-kinetic-control-toolbox (1.10.1-0xenial) xenial; urgency=high

  * Add dependency on tinyxml.
  * Contributors: Austin Hendrix



=== debian/control ===
Source: ros-kinetic-control-toolbox
Section: misc
Priority: extra
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libtinyxml-dev, ros-kinetic-catkin (>= 0.5.68), ros-kinetic-cmake-modules, ros-kinetic-control-msgs, ros-kinetic-dynamic-reconfigure, ros-kinetic-message-generation, ros-kinetic-realtime-tools, ros-kinetic-roscpp, ros-kinetic-rosunit, ros-kinetic-std-msgs
Homepage: http://ros.org/wiki/control_toolbox
Standards-Version: 3.9.2

Package: ros-kinetic-control-toolbox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libtinyxml-dev, ros-kinetic-control-msgs, ros-kinetic-dynamic-reconfigure, ros-kinetic-message-runtime, ros-kinetic-realtime-tools, ros-kinetic-roscpp, ros-kinetic-std-msgs
Description: The control toolbox contains modules that are useful across all controllers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-control-toolbox//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
